#include "Riostream.h"
#include "Event.h"


ClassImp(Event)
ClassImp(Track)
ClassImp(Layer)
  
//TClonesArray *Layer::fgTracks = 0;

Layer::Layer()
{
  fTracks = 0;
}

Layer::Layer(Int_t N)
{
  fN = N;
  fNtrack = 0;
  //if (!fgTracks) fgTracks = new TClonesArray("Track", 2);
  // fTracks = fgTracks;
  fTracks = new TClonesArray("Track", 2);
}

Layer::~Layer()
{
  Clear();
  if (fTracks) delete fTracks;
}

void Layer::Clear()
{
  if (fTracks) {
    fTracks->Clear("C"); // will also call Track::Clear
  }
}

void Layer::Reset()
{
  //  delete fgTracks; fgTracks = 0;
}

Track *Layer::AddTrack(Int_t event, Int_t layer)
{
  TClonesArray &tracks = *fTracks;
  Track *track = new(tracks[fNtrack++]) Track(event, layer);
  
  return track;
}

void Layer::Print()
{
  cout << "\t### Layer " << fN << " ###" << endl;
  TIter next(fTracks);
  while(Track *track = (Track*)next()) track->Print();
  cout << "\t" << fTracks->GetEntries() << " tracks found" << endl;
}

//______________________________________________________________________________
Event::Event(Int_t N)
{
  fN = 0;
  for (int i=0; i<2; i++) fLayers[i] = new Layer(i);
}

Event::~Event()
{
  Clear();
  for (int i=0; i<2; i++) delete fLayers[i];
}


void Event::Clear(Option_t * /*option*/)
{
  for (int i=0; i<2; i++) fLayers[i]->Clear();
}

void Event::Print()
{
  cout << "### Event " << fN << " ###" << endl;
  for (int i=0; i<2; i++) fLayers[i]->Print();
}

//______________________________________________________________________________
Track::Track(const Track &orig) : TObject(orig)
{
  fEvent = orig.fEvent;
  fLayer = orig.fLayer;
}

Track::Track(Int_t event, Int_t layer) : TObject()
{
  fEvent = event;
  fLayer = layer;
}

void Track::Clear(Option_t * /*option*/)
{
  fEvent = 0;
  fLayer = 0;
}

void Track::Print()
{
  cout << "\t\t track: event " << fEvent << "; layer " << fLayer << endl;
}

